<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_BookingAdvancedOptions StructType
 * @subpackage Structs
 */
abstract class JP_BookingAdvancedOptions extends JP_BaseAdvancedOptions
{
    /**
     * The UseCurrency
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UseCurrency;
    /**
     * The SendMailTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SendMailTo;
    /**
     * The ShowBreakdownPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $ShowBreakdownPrice;
    /**
     * Constructor method for JP_BookingAdvancedOptions
     * @uses JP_BookingAdvancedOptions::setUseCurrency()
     * @uses JP_BookingAdvancedOptions::setSendMailTo()
     * @uses JP_BookingAdvancedOptions::setShowBreakdownPrice()
     * @param string $useCurrency
     * @param string $sendMailTo
     * @param bool $showBreakdownPrice
     */
    public function __construct($useCurrency = null, $sendMailTo = null, $showBreakdownPrice = null)
    {
        $this
            ->setUseCurrency($useCurrency)
            ->setSendMailTo($sendMailTo)
            ->setShowBreakdownPrice($showBreakdownPrice);
    }
    /**
     * Get UseCurrency value
     * @return string|null
     */
    public function getUseCurrency()
    {
        return $this->UseCurrency;
    }
    /**
     * Set UseCurrency value
     * @param string $useCurrency
     * @return \StructType\JP_BookingAdvancedOptions
     */
    public function setUseCurrency($useCurrency = null)
    {
        // validation for constraint: string
        if (!is_null($useCurrency) && !is_string($useCurrency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($useCurrency, true), gettype($useCurrency)), __LINE__);
        }
        $this->UseCurrency = $useCurrency;
        return $this;
    }
    /**
     * Get SendMailTo value
     * @return string|null
     */
    public function getSendMailTo()
    {
        return $this->SendMailTo;
    }
    /**
     * Set SendMailTo value
     * @uses \EnumType\JP_SendMailTo::valueIsValid()
     * @uses \EnumType\JP_SendMailTo::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sendMailTo
     * @return \StructType\JP_BookingAdvancedOptions
     */
    public function setSendMailTo($sendMailTo = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JP_SendMailTo::valueIsValid($sendMailTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JP_SendMailTo', is_array($sendMailTo) ? implode(', ', $sendMailTo) : var_export($sendMailTo, true), implode(', ', \EnumType\JP_SendMailTo::getValidValues())), __LINE__);
        }
        $this->SendMailTo = $sendMailTo;
        return $this;
    }
    /**
     * Get ShowBreakdownPrice value
     * @return bool|null
     */
    public function getShowBreakdownPrice()
    {
        return $this->ShowBreakdownPrice;
    }
    /**
     * Set ShowBreakdownPrice value
     * @param bool $showBreakdownPrice
     * @return \StructType\JP_BookingAdvancedOptions
     */
    public function setShowBreakdownPrice($showBreakdownPrice = null)
    {
        // validation for constraint: boolean
        if (!is_null($showBreakdownPrice) && !is_bool($showBreakdownPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showBreakdownPrice, true), gettype($showBreakdownPrice)), __LINE__);
        }
        $this->ShowBreakdownPrice = $showBreakdownPrice;
        return $this;
    }
}
